// create our OSC receiver
OscRecv recv;
//Receive port
6453 => recv.port;
// start listening (launch thread)
recv.listen();

// create an address in the receiver, store in new variable
recv.event( "/javaGUI/buttonHit i" ) @=> OscEvent buttonEvent;
recv.event( "/javaGUI/sliderUpdate i" ) @=> OscEvent sliderEvent;

SinOsc s => dac;
Mandolin m => dac;
.5 => s.gain;
.5 => m.gain;

Envelope targetFreq => blackhole;
.1::second => targetFreq.duration;


spork ~waitButton();
spork ~waitSlider();
spork ~updateFreq();
while (true) {
	1::hour => now;
}

fun void waitButton() {
	while ( true )
	{
    	// wait for event to arrive
    	buttonEvent => now;

    	// grab the next message from the queue. 
	    while ( buttonEvent.nextMsg() != 0 )
    	{ 
        	buttonEvent.getInt();
        	<<< "button" >>>;
			1 => m.noteOn;
    	}
	}
}

fun void waitSlider() {
	int newFreq;
	while ( true )
	{
    	// wait for event to arrive
    	sliderEvent => now;

    	// grab the next message from the queue. 
	    while ( sliderEvent.nextMsg() != 0 )
    	{ 
			sliderEvent.getInt() => newFreq;
        	<<< "Slider: ",  newFreq >>>;
			newFreq => targetFreq.target;
    	}
	}
}


fun void updateFreq() {
	while (true) {
		targetFreq.value() => s.freq;
		10::ms => now;
	}

}