//Need libraries for OSC:
import oscP5.*;
import netP5.*;

//Library to use an arraylist object (to keep track of Circles)
import java.util.LinkedList;


//Required OSC objects
OscP5 oscP5;
NetAddress myBroadcastLocation; 


// list that holds Circles
LinkedList circles;
int circleCount = 1;
// max and min size of circles
float maxSize = 80;
float minSize = 2;
// max speed for circles
float speed = 0;
// glow toggle
boolean glow=false;


void setup() {
  colorMode(HSB);
  size(640,480,OPENGL);
  background(0);
  noStroke();
  smooth();

  // make a list of circle objects
  circles = new LinkedList();
  
    oscP5 = new OscP5(this,12000);
    myBroadcastLocation = new NetAddress("127.0.0.1",6453);
}

void draw() {
  fill(0,25);
  noStroke();
  rect(0,0,width,height);


  // loop through the circle objects in circles list
  for (int i=0; i<circles.size(); i++) {
    Circle circle = (Circle) circles.get(i);
    circle.grow();
    circle.display();
  }
}

void mouseClicked() {
   circles.add(new Circle(mouseX, mouseY, random(maxSize - minSize) + minSize, .1, circles));
   OscMessage myOscMessage = new OscMessage("/mouseClick");
  /* add a value (an integer) to the OscMessage */
  println(mouseX + "," + mouseY);
  myOscMessage.add(mouseX);
  myOscMessage.add(mouseY);
  /* send the OscMessage to a remote location specified in myNetAddress */
  oscP5.send(myOscMessage, myBroadcastLocation);
}

class Circle {
  // x and y position, radius, x and y velocities
  float x, y, r;
  float rate;
  // circle color
  color c;
  float h, s, b;
  float greenc = 0;
  LinkedList myList;

  Circle(float _x, float _y, float _r, float _rate, LinkedList listy) {
    x = _x;  
    y = _y;  
    r = _r;  
    rate = _rate;
    h = random(255);
    s = 255;
    b = 255;
    c = color(h, s,b);
    myList = listy;
  }

  // draw circle
  void display() {
    fill(c,100);
    ellipse(x, y, r*2, r*2);
  }

  void grow() {
     r = r + rate;
     if (b > 30) {
         b = b - 1;
          c = color(h,s,b);
      } else {
          myList.remove(this);
      }
  }
} 




